// DateTimeThread.cpp - work thread implementation file for GETTIME.EXE
//
// THIS SOFTWARE IS Copyright 1999 by Bob Frazier and SFT Inc. - All rights reserved
// It has been provided to the public as "copy-left" according to the terms of the
// GNU GENERAL PUBLIC LICENSE at http://www.gnu.org/copyleft/gpl.html
//
// THIS CODE IS PROVIDED 'AS-IS' with NO WARRANTEE WHATSOEVER
// USE IT AT YOUR OWN RISK - Bob Frazier and SFT Inc. CLAIM NO
// RESPONSIBILITY FOR ANY DAMAGES, CONSEQUENTIAL OR OTHERWISE,
// THAT MAY RESULT FROM USE OR ABUSE OF THIS PROGRAM, WHETHER
// IN ITS ORIGINAL OR MODIFIED STATE.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// For a copy of the GNU General Public License, you can visit the
// 'gnu.org' web site at http://www.gnu.org/, or write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#include "stdafx.h"
#include "excpt.h"
#include "gettime.h"
#include "DateTimeThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// function prototypes

void InvokeThread(CDateTimeThread *);



/////////////////////////////////////////////////////////////////////////////
// CDateTimeThread

IMPLEMENT_DYNCREATE(CDateTimeThread, CWinThread)

CDateTimeThread::CDateTimeThread()
{
}

CDateTimeThread::~CDateTimeThread()
{
}

BOOL CDateTimeThread::InitInstance()
{
  WSADATA wsa;
  AfxSocketInit(&wsa);

  // in order to use c-style exception handling we must not create
  // any C++ objects in here.  Therefore I must invoke the
  // process through a 'C-style' function.

  InvokeThread(this);


	return TRUE;
}

int CDateTimeThread::ExitInstance()
{

	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CDateTimeThread, CWinThread)
	//{{AFX_MSG_MAP(CDateTimeThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDateTimeThread message handlers

int MyCatchException(int iExceptionCode)
{
  CString csTemp;
  csTemp.Format("Unhandled exception %d (%08xH) during execution of thread",
                iExceptionCode, iExceptionCode);

#ifdef _DEBUG
  if(iExceptionCode == EXCEPTION_ACCESS_VIOLATION ||
     iExceptionCode == EXCEPTION_BREAKPOINT ||
     iExceptionCode == EXCEPTION_SINGLE_STEP ||
     iExceptionCode == EXCEPTION_ARRAY_BOUNDS_EXCEEDED ||
     iExceptionCode == EXCEPTION_FLT_DENORMAL_OPERAND ||
     iExceptionCode == EXCEPTION_FLT_DIVIDE_BY_ZERO ||
     iExceptionCode == EXCEPTION_FLT_INEXACT_RESULT ||
     iExceptionCode == EXCEPTION_FLT_INVALID_OPERATION ||
     iExceptionCode == EXCEPTION_FLT_OVERFLOW ||
     iExceptionCode == EXCEPTION_FLT_STACK_CHECK ||
     iExceptionCode == EXCEPTION_FLT_UNDERFLOW ||
     iExceptionCode == EXCEPTION_INT_DIVIDE_BY_ZERO ||
     iExceptionCode == EXCEPTION_INT_OVERFLOW ||
     iExceptionCode == EXCEPTION_INVALID_HANDLE)
  {
    // I'm probably debugging, so allow certain things to get through
    // so that the debugger will break instead of the exception handler

    return(EXCEPTION_CONTINUE_SEARCH);
  }

#endif // _DEBUG

  if(iExceptionCode == EXCEPTION_ACCESS_VIOLATION ||
     iExceptionCode == EXCEPTION_ARRAY_BOUNDS_EXCEEDED ||
     iExceptionCode == EXCEPTION_PRIV_INSTRUCTION ||
     iExceptionCode == EXCEPTION_IN_PAGE_ERROR ||
     iExceptionCode == EXCEPTION_ILLEGAL_INSTRUCTION ||
     iExceptionCode == EXCEPTION_NONCONTINUABLE_EXCEPTION ||
     iExceptionCode == EXCEPTION_STACK_OVERFLOW ||
     iExceptionCode == EXCEPTION_INVALID_DISPOSITION ||
     iExceptionCode == EXCEPTION_INVALID_HANDLE)
  {
    AddToMessageLog(csTemp + " - terminating thread.");

    return(EXCEPTION_EXECUTE_HANDLER);
  }
  else if(iExceptionCode == EXCEPTION_FLT_DENORMAL_OPERAND ||
          iExceptionCode == EXCEPTION_FLT_DIVIDE_BY_ZERO ||
          iExceptionCode == EXCEPTION_FLT_INEXACT_RESULT ||
          iExceptionCode == EXCEPTION_FLT_INVALID_OPERATION ||
          iExceptionCode == EXCEPTION_FLT_OVERFLOW ||
          iExceptionCode == EXCEPTION_FLT_STACK_CHECK ||
          iExceptionCode == EXCEPTION_FLT_UNDERFLOW ||
          iExceptionCode == EXCEPTION_INT_DIVIDE_BY_ZERO ||
          iExceptionCode == EXCEPTION_INT_OVERFLOW ||
          iExceptionCode == CONTROL_C_EXIT)
  {
    AddToMessageLog(csTemp + " - continuing thread.");

    return(EXCEPTION_CONTINUE_EXECUTION);
  }
  else
  {
#ifdef _DEBUG
    AddToMessageLog(csTemp + " - not handled (continuing search).");
#endif // _DEBUG

    return(EXCEPTION_CONTINUE_SEARCH);
  }
}

void InvokeThread(CDateTimeThread *pThread)
{
  __try
  {
    pThread->DoThreadProcess();
  }
  __except(MyCatchException(_exception_code()))
  {
    char tbuf[256];

    wsprintf(tbuf,"Unhandled exception %d (%08xH) during execution of thread",
             _exception_code(), _exception_code());

    AddToMessageLog(tbuf);

    theApp.PostThreadMessage(WM_QUIT, 0, 0);  // post a quit message
  }

  // return now... hopefully all things are ok
}



void CDateTimeThread::DoThreadProcess()
{
  // yo, let's have fun!

  AddToMessageLog(_T("GetTime - thread starting"), EVENTLOG_INFORMATION_TYPE);

  MSG msg;
  int i1, i2;
  CString csTemp;
  DWORD dwTick = GetTickCount() - 1;
  
  do
  {
    if((int)(GetTickCount() - dwTick) > 0)
    {
      BOOL bSuccess = FALSE;
      CSocket sock;

      if(sock.Create())
      {
        // connect to server
        int iPort = 13;  // default
        i1 = m_csAddr.ReverseFind(':');

        if(i1 >= 0)
        {
          iPort = atoi(m_csAddr.Mid(i1 + 1));
          m_csAddr = m_csAddr.Left(i1);
        }

        if(m_csSocks.GetLength())
        {
          // use SOCKS server to access 'daytime' server (TODO)

          int iSocksPort = 1080;
          i1 = m_csSocks.ReverseFind(':');

          if(i1 >= 0)
          {
            iSocksPort = atoi(m_csSocks.Mid(i1 + 1));
            m_csSocks = m_csSocks.Left(i1);
          }

          if(sock.Connect(m_csSocks, iSocksPort))
          {
            // send a "protocol request"

            BYTE aPacket[256];  // a temporary place to stick stuff
            int iVer = 0;

            aPacket[0] = 5;  // SOCKS version 5
            aPacket[1] = 2;  // # of methods (2)
            aPacket[2] = 0;  // "no password" method
            aPacket[3] = 2;  // username/password method

            if(sock.Send(aPacket, 4) == SOCKET_ERROR)  // send 4 bytes
            {
              dwLastErr = sock.GetLastError();

              TRACE("** SocksSocket SEND ERROR %08xH (%d) **\r\n", dwLastErr);
            }
            else
            {
              // now get back the reply (should be 2 bytes)

              int iRval = sock.Receive(aPacket, sizeof(aPacket));

              if(iRval == SOCKET_ERROR)
              {
                dwLastErr = sock.GetLastError();

                TRACE("** SocksSocket RECEIVE ERROR %08xH (%d) **\r\n", dwLastErr);
              }
              else
              {
                ASSERT(iRval == 2);

                iVer = 5;

                if(aPacket[0] < 5)  // socks version 4?
                {
                  iVer = aPacket[0];

                  TRACE("** SocksSocket - WARNING - version %d**\r\n", iVer);
                }

                iRval = 0;  // "fail" code

                if(aPacket[1] == 0)  // no authorization
                {
                  TRACE0("** SocksSocket - No Authorization Required **\r\n");
                  iRval = 1;  // "success" code
                }
                else if(aPacket[1] == 2) // user/password
                {
                  TRACE0("** SocksSocket - User/Password Required **\r\n");

                  // send "guest" and "guest" - see RFC1929

                  char szUser[]="guest";
                  char szPass[]="guest";  // for now

                  aPacket[0] = iVer;
                  aPacket[1] = strlen(szUser);
                  memcpy(aPacket + 2, szUser, strlen(szUser));
                  aPacket[2 + strlen(szUser)] = strlen(szPass);
                  memcpy(aPacket + 3 + strlen(szUser), szPass, strlen(szPass));

                  int cbLen = strlen(szUser) + strlen(szPass) + 3;

                  if(sock.Send(aPacket, 3 + cbLen) == SOCKET_ERROR)  // send n bytes
                  {
                    dwLastErr = sock.GetLastError();

                    TRACE("** SocksSocket SEND ERROR(2) %08xH (%d) **\r\n", dwLastErr);
                  }
                  else
                  {
                    int iRval2 = sock.Receive(aPacket, sizeof(aPacket));

                    if(iRval2 == SOCKET_ERROR)
                    {
                      dwLastErr = sock.GetLastError();

                      TRACE("** SocksSocket RECEIVE ERROR %08xH (%d) **\r\n", dwLastErr);
                    }
                    else
                    {
                      ASSERT(iRval2 == 2);

                      if(aPacket[1] != 0) // an error
                      {
                        TRACE("** SocksSocket SECURITY AUTHORIZATION FAILURE %d **\r\n",
                              (BYTE)aPacket[1]);
                      }
                      else
                      {
                        iRval = 1;  // success flag
                      }
                    }
                  }
                }
                else if(aPacket[1] == 255) // NONE
                {
                  TRACE0("** SocksSocket - NO PROTOCOL **\r\n");
                }
                else
                {
                  TRACE0("** SocksSocket - UNSUPPORTED SECURITY PROTOCOL **\r\n");
                }

                if(iRval)  // i.e. it worked
                {
//                  aPacket[0] = iVer;
//                  aPacket[1] = 1; // CONNECT (bind = 2, UDP ASSOCIATE = 3)
//                  aPacket[2] = 0; // RESERVED (must be zero)
//                  aPacket[3] = 1; // address type (V4 IP (4 byte) = 1, domain = 3, V6 IP (16 byte) = 4)
//                  aPacket[4] = (BYTE)((SOCKADDR_IN *)lpSockAddr)->sin_addr.S_un.S_un_b.s_b1;
//                  aPacket[5] = (BYTE)((SOCKADDR_IN *)lpSockAddr)->sin_addr.S_un.S_un_b.s_b2;
//                  aPacket[6] = (BYTE)((SOCKADDR_IN *)lpSockAddr)->sin_addr.S_un.S_un_b.s_b3;
//                  aPacket[7] = (BYTE)((SOCKADDR_IN *)lpSockAddr)->sin_addr.S_un.S_un_b.s_b4;
//                  aPacket[8] = ((BYTE *)&(((SOCKADDR_IN *)lpSockAddr)->sin_port))[0];
//                  aPacket[9] = ((BYTE *)&(((SOCKADDR_IN *)lpSockAddr)->sin_port))[1];

                  aPacket[0] = iVer;
                  aPacket[1] = 1; // CONNECT (bind = 2, UDP ASSOCIATE = 3)
                  aPacket[2] = 0; // RESERVED (must be zero)
                  aPacket[3] = 3; // address type (V4 IP (4 byte) = 1, domain = 3, V6 IP (16 byte) = 4)

                  aPacket[4] = (BYTE)m_csAddr.GetLength();  // length byte first
                  memcpy(aPacket + 5, m_csAddr, m_csAddr.GetLength());  // then data

                  aPacket[m_csAddr.GetLength() + 5] = (BYTE)((iPort  >> 8) & 0xff);
                  aPacket[m_csAddr.GetLength() + 6] = (BYTE)(iPort & 0xff);

                  if(sock.Send(aPacket, m_csAddr.GetLength() + 7) == SOCKET_ERROR)  // send n bytes
                  {
                    dwLastErr = sock.GetLastError();

                    TRACE("** SocksSocket SEND ERROR %08xH (%d) **\r\n", dwLastErr);
                  }
                  else
                  {
                    iRval = sock.Receive(aPacket, sizeof(aPacket));

                    if(iRval == SOCKET_ERROR)
                    {
                      dwLastErr = sock.GetLastError();

                      TRACE("** SocksSocket RECEIVE ERROR %08xH (%d) **\r\n", dwLastErr, dwLastErr);
                    }
                    else
                    {
                      ASSERT(iRval == 10);
                      ASSERT(aPacket[0] == iVer);

                      if(aPacket[1] != 0)  // there was an error
                      {
                    #ifdef _DEBUG
                        char *szErrors[]={"N/A",
                                          "general SOCKS server failure",
                                          "connection not allowed by ruleset",
                                          "Network unreachable",
                                          "Host unreachable",
                                          "Connection refused",
                                          "TTL expired",
                                          "Command not supported",
                                          "Address type not supported"};

                        if(aPacket[1] >= (sizeof(szErrors) / sizeof(*szErrors)))
                        {
                          TRACE("** SocksSocket CONNECT FAILED - ERROR %d **\r\n",
                                (BYTE)aPacket[1]);
                        }
                        else
                        {
                          TRACE("** SocksSocket CONNECT FAILED - %s **\r\n",
                                szErrors[aPacket[1]]);
                        }
                    #endif // _DEBUG
                      }
                      else
                      {
    //                    m_csPeer.Format("%s:%u", lpszHostAddress, nHostPort);
    //
    //                    ASSERT(aPacket[3] == 1); // IP V4 address (4 byte)
    //
    //                    if(aPacket[3] == 1)  // IP V4 Address (4 byte)
    //                    {
    //                      m_addrProxy.sin_family = AF_INET;
    //
    //                      m_addrProxy.sin_addr.S_un.S_un_b.s_b1 = aPacket[4];
    //                      m_addrProxy.sin_addr.S_un.S_un_b.s_b2 = aPacket[5];
    //                      m_addrProxy.sin_addr.S_un.S_un_b.s_b3 = aPacket[6];
    //                      m_addrProxy.sin_addr.S_un.S_un_b.s_b4 = aPacket[7];
    //                      m_addrProxy.sin_port = *((WORD *)((LPBYTE)aPacket + 8));
    //
    //                  #ifdef _DEBUG
    //                      CString csProxyAddress;
    //                      csProxyAddress.Format("%d.%d.%d.%d:%u",
    //                                            (BYTE)m_addrProxy.sin_addr.S_un.S_un_b.s_b1,
    //                                            (BYTE)m_addrProxy.sin_addr.S_un.S_un_b.s_b2,
    //                                            (BYTE)m_addrProxy.sin_addr.S_un.S_un_b.s_b3,
    //                                            (BYTE)m_addrProxy.sin_addr.S_un.S_un_b.s_b4,
    //                                            (WORD)htons(m_addrProxy.sin_port));
    //
    //                      TRACE0("** SocksSocket - PROXY ADDRESS IS " + csProxyAddress + " **\r\n");
    //                  #endif // _DEBUG

                        LPSTR lp1 = csTemp.GetBufferSetLength(4096);

                        i1 = sock.Receive(lp1, 4096);

                        if(i1 <= 0)
                          csTemp.ReleaseBuffer(-1);
                        else
                        {
                          csTemp.ReleaseBuffer(i1);

                          csTemp.TrimRight();
                          csTemp.TrimLeft();

                          bSuccess = TRUE;
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        else
        {
          if(sock.Connect(m_csAddr, iPort))
          {
            // read data from socket

            LPSTR lp1 = csTemp.GetBufferSetLength(4096);

            i1 = sock.Receive(lp1, 4096);

            if(i1 <= 0)
              csTemp.ReleaseBuffer(-1);
            else
            {
              csTemp.ReleaseBuffer(i1);

              csTemp.TrimRight();
              csTemp.TrimLeft();

              bSuccess = TRUE;
            }
          }
        }

        if(bSuccess)
        {
//          // TEMPORARY
//
//          AddToMessageLog(_T("TEMPORARY - GetTime successfully read ") + csTemp,
//                          EVENTLOG_INFORMATION_TYPE);

          // date/time received - translate it

          CStringArray acsTerms; // array of terms separated by white space
          
          LPCSTR lpc1 = csTemp, lpc2;

          TRACE0(csTemp + "\r\n");

          while(*lpc1 && *lpc1 <= ' ')
            lpc1++; // next non-white-space

          while(*lpc1)
          {
            for(lpc2 = lpc1 + 1; *lpc2 > ' '; lpc2++)
              ;

            TRACE0(((CString)lpc1).Left(lpc2 - lpc1) + "\r\n");

            if(lpc2 > lpc1 && *(lpc2 - 1) != ',')  // trailing commas must go away
              acsTerms.Add(((CString)lpc1).Left(lpc2 - lpc1));
            else if((lpc2 - lpc1 - 1) > 0)
              acsTerms.Add(((CString)lpc1).Left(lpc2 - lpc1 - 1));

            lpc1 = lpc2;

            while(*lpc1 && *lpc1 <= ' ')
              lpc1++; // next non-white-space
          }

          SYSTEMTIME tm, tmOld;
          BOOL bChanged = FALSE;
          BOOL bGMT = FALSE;
          int iTZDelta = 0;

          if(m_csTZ.GetLength() &&
             (!m_csTZ.CompareNoCase("UTC") ||
              !m_csTZ.CompareNoCase("GMT")))
          {
            bGMT = TRUE;
            GetSystemTime(&tmOld);  // gets time/date in GMT
          }
          else
          {
            if(m_csTZ.GetLength())
            {
              if(m_csTZ[0] == '+')
                iTZDelta = atoi(m_csTZ.Mid(1));
              else
                iTZDelta = atoi(m_csTZ);
            }

            GetLocalTime(&tmOld);
          }

          memcpy(&tm, &tmOld, sizeof(tm));

          BOOL bDayCross = FALSE, bDateFound = FALSE, bTimeFound = FALSE, bYearFound = FALSE;

          for(i1=0; i1 < acsTerms.GetSize(); i1++)
          {
            csTemp = acsTerms[i1];

            // is it a date (YY-MM-DD)

            if((i2 = csTemp.Find('-')) > 0 &&  // found '-', not the first character
               csTemp.SpanIncluding("0123456789-").GetLength() == csTemp.GetLength())
            {
              if(bDateFound && bYearFound)
                continue;   // I don't need this now - already 'satisified'

              // determine the date format - assume 'YY-MM-DD' for now

              int iYear = atoi(csTemp.Left(i2));
              csTemp = csTemp.Mid(i2 + 1);

              i2 = csTemp.Find('-');

              if(i2 >= 0)
              {
                int iMonth = atoi(csTemp.Left(i2));
                int iDay = atoi(csTemp.Mid(i2 + 1));

                if(iYear < 100) // 2-digit year - good through 2098 - to fix later, modify code
                {
                  if(iYear == 99)
                    iYear += 1900;
                  else
                    iYear += 2000;
                }

                ASSERT(iYear >= 1999 && iYear < 2099);  // a sanity check

                ASSERT(!bYearFound || iYear == tm.wYear);  // more debug checks

                bDateFound = TRUE;
                bYearFound = TRUE; // this takes precedence over ANYTHING else

                if((int)tm.wYear != iYear ||
                   (int)tm.wMonth != iMonth ||
                   (int)tm.wDay != iDay)
                {
                  bChanged = TRUE;

                  tm.wYear = iYear;
                  tm.wMonth = iMonth;
                  tm.wDay = iDay; // assume it's valid
                }
              }
            }
            else if((i2 = csTemp.Find('/')) > 0 &&  // found '/', not the first character
                    csTemp.SpanIncluding("0123456789/").GetLength() == csTemp.GetLength())
            {
              if(bDateFound && bYearFound)
                continue;   // I don't need this now - already 'satisified'

              // determine the date format - assume 'YY/MM/DD' for now

              int iYear = atoi(csTemp.Left(i2));
              csTemp = csTemp.Mid(i2 + 1);

              i2 = csTemp.Find('/');

              if(i2 >= 0)
              {
                int iMonth = atoi(csTemp.Left(i2));
                int iDay = atoi(csTemp.Mid(i2 + 1));

                if(iYear < 100) // 2-digit year - good through 2098 - to fix later, modify code
                {
                  if(iYear == 99)
                    iYear += 1900;
                  else
                    iYear += 2000;
                }

                ASSERT(iYear >= 1999 && iYear < 2099);  // a sanity check

                ASSERT(!bYearFound || iYear == tm.wYear);  // more debug checks

                bDateFound = TRUE;
                bYearFound = TRUE; // this takes precedence over ANYTHING else

                if((int)tm.wYear != iYear ||
                   (int)tm.wMonth != iMonth ||
                   (int)tm.wDay != iDay)
                {
                  bChanged = TRUE;

                  tm.wYear = iYear;
                  tm.wMonth = iMonth;
                  tm.wDay = iDay; // assume it's valid
                }
              }
            }

            // is it a time (HH:MM:SS [AM|PM])

            else if((i2 = csTemp.Find(':')) > 0 &&  // found '-', not the first character
                    csTemp.SpanIncluding("0123456789:ampAMP").GetLength() == csTemp.GetLength())
            {
              if(bTimeFound)
                continue;   // I don't need this now - already 'satisified'

              // is next one AM or PM?  Let's see...

              BOOL bAM = FALSE, bPM = FALSE;

              if(csTemp.GetLength() > 2 && !csTemp.Right(2).CompareNoCase("AM"))
              {
                bAM = TRUE;
                csTemp = csTemp.Left(csTemp.GetLength() - 2);
              }
              else if(csTemp.GetLength() > 2 && !csTemp.Right(2).CompareNoCase("PM"))
              {
                bPM = TRUE;
                csTemp = csTemp.Left(csTemp.GetLength() - 2);
              }
              else // if(csTemp.Find("AM") < 0 && csTemp.Find("PM") < 0)
              {
                if((i1 + 1) < acsTerms.GetSize() && 
                   !acsTerms[i1 + 1].CompareNoCase("AM"))
                {
                  bAM = TRUE;
                }
                else if((i1 + 1) < acsTerms.GetSize() && 
                        !acsTerms[i1 + 1].CompareNoCase("PM"))
                {
                  bPM = TRUE;
                }
              }

              // determine the time format - assume 'HH:MM:SS' for now with optional '.nnnn'

              int iHour = atoi(csTemp.Left(i2));
              csTemp = csTemp.Mid(i2 + 1);

              if(bAM)
              {
                if(iHour == 12)  // 12 AM
                  iHour = 0;
              }
              else if(bPM)
              {
                if(iHour < 12)  // not 12 PM
                  iHour += 12;  // add 12 to the hour 
              }

              ASSERT(iHour >= 0 && iHour < 24);

              if(!bGMT) // adjust for time zone, when applicable
              {
                bDayCross = (iHour + iTZDelta) >= 24
                         || (iHour + iTZDelta) < 0;

                iHour = (iHour + iTZDelta) % 24;
              }

              i2 = csTemp.Find(':');

              if(i2 >= 0)
              {
                int iMinute = atoi(csTemp.Left(i2));
                int iSecond = atoi(csTemp.Mid(i2 + 1));

                bTimeFound = TRUE;

                long lHMS1 = tm.wHour * 3600 + tm.wMinute * 60 + tm.wSecond;
                long lHMS2 = iHour * 3600 + iMinute * 60 + iSecond;

                if(abs(lHMS1 - lHMS2) >= 5) // NOTE:  midnight may cause occasional extra changes
                {
                  tm.wHour = iHour;
                  tm.wMinute = iMinute;
                  tm.wSecond = iSecond;  // don't test for changes yet...

                  bChanged = TRUE;
                }
              }
            }

            // check for YEAR only

            else if(csTemp.SpanIncluding("0123456789").GetLength() == csTemp.GetLength()
                    && atoi(csTemp) >= 1999 && atoi(csTemp) < 2099
                    && !bYearFound)
            {
              int iYear = atoi(csTemp);

              if((int)tm.wYear != iYear)
              {
                tm.wYear = iYear;
                bChanged = TRUE;
              }

              bYearFound = TRUE;
            }

            // check for month only (using month name) - must also precede the day

            else if(!bDateFound && csTemp.GetLength())
            {
              static const char *szMonth[12]={
                "January","February","March","April","May","June","July",
                "August","September","October","November","December" };

              int iMonth;
              for(iMonth=1; iMonth <= 12; iMonth++)
              {
                if(!strnicmp((LPCSTR)csTemp, szMonth[iMonth - 1], csTemp.GetLength()))
                  break;
              }

              if(iMonth <= 12 && acsTerms.GetSize() > (i1 + 1))
              {
                // DAY must follow...

                int iDay = atoi(acsTerms[i1 + 1]);

                if(iDay >= 1 && iDay <= 31) // assume valid, even for Februrary
                {
                  if((int)tm.wMonth != iMonth ||
                     (int)tm.wDay != iDay)
                  {
                    tm.wMonth = iMonth;
                    tm.wDay = iDay;

                    bChanged = TRUE;
                  }

                  bDateFound = TRUE;
                  i1++; // go PAST the next one (no need to re-visit, eh?)
                }
              }
            }
          }

          if(!bChanged && (bTimeFound || (bDateFound && bYearFound)))
          {
            bSuccess = TRUE;  // ok - everything's cool - no change
          }
          else if(bChanged)
          {
            if((bDateFound && !bYearFound) || (bYearFound && !bDateFound))
            {
              ASSERT(0);  // not good (debug only)
            }
            else if(!bTimeFound)
            {
              // time not found - don't change anything, but result is "good"

              ASSERT(0);

              bSuccess = TRUE;  // to prevent frequent "hits"
            }
            else // everything's ok for changing
            {
              // NOTE:  if I 'cross a day' then I might not have to change the
              //        date on it.

              if(bDayCross && iTZDelta != 0) // just in case, validate iTZDelta
              {
                // which direction:

                if(iTZDelta > 0)
                {
                  // the date is too small.  Add one day to it.

                  if(tm.wMonth == 2)
                  {
                    if((tm.wYear % 4) != 0 ||  // not a leap year
                       ((tm.wYear % 100) == 0 && (tm.wYear % 400) != 0))
                    {
                      if(tm.wDay >= 29)
                      {
                        tm.wMonth = 3;
                        tm.wDay = 1;
                      }
                      else
                        tm.wDay++;
                    }
                    else
                    {
                      if(tm.wDay >= 28)
                      {
                        tm.wMonth = 3;
                        tm.wDay = 1;
                      }
                      else
                        tm.wDay++;
                    }
                  }
                  else if(tm.wMonth == 4 || tm.wMonth == 6 || // april, june
                          tm.wMonth == 9 || tm.wMonth == 11)  // september, november
                  {
                    if(tm.wDay >= 30)
                    {
                      tm.wMonth++;
                      tm.wDay = 1;
                    }
                    else
                      tm.wDay++;
                  }
                  else if(tm.wMonth == 12) // december
                  {
                    if(tm.wDay >= 31)
                    {
                      tm.wYear++;
                      tm.wMonth = 1;
                      tm.wDay = 1;
                    }
                    else
                      tm.wDay++;
                  }
                  else // 31 days
                  {
                    if(tm.wDay >= 31)
                    {
                      tm.wMonth++;
                      tm.wDay = 1;
                    }
                    else
                      tm.wDay++;
                  }
                }
                else
                {
                  // the date is too big.  Subtract one day from it.

                  if(tm.wDay == 1)
                  {
                    if(tm.wMonth == 3)
                    {
                      tm.wMonth = 2;

                      if((tm.wYear % 4) != 0 ||  // not a leap year
                         ((tm.wYear % 100) == 0 && (tm.wYear % 400) != 0))
                      {
                        tm.wDay = 29;
                      }
                      else
                      {
                        tm.wDay = 28;
                      }
                    }
                    else if(tm.wMonth == 5 || tm.wMonth == 7 ||  // may, july
                            tm.wMonth == 10 || tm.wMonth == 12)  // october, december
                    {
                      tm.wMonth--;
                      tm.wDay = 30;
                    }
                    else if(tm.wMonth == 1) // january
                    {
                      tm.wYear--;
                      tm.wMonth = 12;
                      tm.wDay = 31;
                    }
                    else // 31 days
                    {
                      tm.wMonth--;
                      tm.wDay = 31;
                    }
                  }
                  else
                  {
                    tm.wDay--;
                  }
                }

                // verify that the date/time really *DID* change, now...

                if(tm.wDay != tmOld.wDay ||
                   tm.wMonth != tmOld.wMonth ||
                   tm.wYear != tmOld.wYear ||
                   abs((long)(tm.wHour * 3600 + tm.wMinute * 60 + tm.wSecond) -
                       (long)(tmOld.wHour * 3600 + tmOld.wMinute * 60 + tmOld.wSecond))
                   > 5)
                {
                  bChanged = TRUE;
                }
                else
                {
                  bChanged = FALSE;
                }
              }

              tm.wMilliseconds = 0;  // make it an 'even second'
              tm.wDayOfWeek = 0;  // just because (it's ignored anyway)

              if(bChanged) // a final check
              {
                csTemp.Format(_T("Changing date/time from %04d/%02d/%02d %02d:%02d:%02d to %04d/%02d/%02d %02d:%02d:%02d\r\n"),
                              tmOld.wYear,tmOld.wMonth,tmOld.wDay,
                              tmOld.wHour,tmOld.wMinute,tmOld.wSecond,
                              tm.wYear,tm.wMonth,tm.wDay,
                              tm.wHour,tm.wMinute,tm.wSecond);

                TRACE0(csTemp);

                AddToMessageLog(csTemp, EVENTLOG_INFORMATION_TYPE);
                   // always update the event log whenever I change it

                if(bGMT)
                {
                  if(!SetSystemTime(&tm))
                  {
                    // if I can't set the time, I must find out *WHY*

                    AddToMessageLog("ERROR - unable to set time!");
                    bSuccess = FALSE;
                  }
                }
                else
                {
                  if(!SetLocalTime(&tm))
                  {
                    // if I can't set the time, I must find out *WHY*

                    AddToMessageLog("ERROR - unable to set time!");
                    bSuccess = FALSE;
                  }
                }
              }
            }
          }
        }
//        else
//        {
//          AddToMessageLog(_T("TEMPORARY - GetTime failed to read date/time from ")
//                          + m_csAddr
//                          + _T(" via ")
//                          + m_csSocks,
//                          EVENTLOG_WARNING_TYPE);
//        }
      }

      if(bDebug)
      {
        dwTick = GetTickCount() + 15000;  // every 15 seconds in 'debug' mode

        if(bSuccess)
          TRACE0("** SUCCESS on last go around **\r\n");
        else
          TRACE0("** FAILURE on last go around **\r\n");
      }
      else if(bSuccess)
        dwTick = GetTickCount() + 2220000; // do this every 37 minutes or so
      else
        dwTick = GetTickCount() + 61000; // try it once per 61 seconds on failure..
    }
    else
    {
      Sleep(500);  // wait .5 seconds
    }

  } while(!::PeekMessage(&msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE));


  AddToMessageLog(_T("GetTime - thread exiting"), EVENTLOG_INFORMATION_TYPE);

}
