// GETTIME.H - main application header file for GETTIME.EXE
//
// THIS SOFTWARE IS Copyright 1999 by Bob Frazier and SFT Inc. - All rights reserved
// It has been provided to the public as "copy-left" according to the terms of the
// GNU GENERAL PUBLIC LICENSE at http://www.gnu.org/copyleft/gpl.html
//
// THIS CODE IS PROVIDED 'AS-IS' with NO WARRANTEE WHATSOEVER
// USE IT AT YOUR OWN RISK - Bob Frazier and SFT Inc. CLAIM NO
// RESPONSIBILITY FOR ANY DAMAGES, CONSEQUENTIAL OR OTHERWISE,
// THAT MAY RESULT FROM USE OR ABUSE OF THIS PROGRAM, WHETHER
// IN ITS ORIGINAL OR MODIFIED STATE.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// For a copy of the GNU General Public License, you can visit the
// 'gnu.org' web site at http://www.gnu.org/, or write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#if !defined(AFX_GETTIME_H__E9DDA65C_C10C_11D2_A41D_004033901FF3__INCLUDED_)
#define AFX_GETTIME_H__E9DDA65C_C10C_11D2_A41D_004033901FF3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

#define SZAPPNAME            _T("gettime")
#define SZSERVICENAME        _T("SFTGetTime")
#define SZSERVICEDISPLAYNAME _T("SFTGetTime 'daytime' TCP client")
#define SZGLOBALEVENTNAME    _T("_SFT_GETTIME_SHUTDOWN_EVENT_")
// list of service dependencies - "dep1\0dep2\0\0"
#define SZDEPENDENCIES       _T("tcpip\0\0")

// global variables

extern SERVICE_STATUS          ssStatus;       // current status of the service
extern SERVICE_STATUS_HANDLE   sshStatusHandle;
extern BOOL                    bDebug;
extern BOOL                    bIsNT;
extern DWORD                   dwLastErr;


/////////////////////////////////////////////////////////////////////////////
// CGetTimeApp - CWinApp derived class

class CGetTimeApp : public CWinApp
{
// Attributes
public:

  CGetTimeApp();
  virtual ~CGetTimeApp();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGetTimeApp)
	//}}AFX_VIRTUAL

  BOOL MyMessageLoop();  // returns TRUE on WM_QUIT
  static CWnd m_wndNULL;  // a 'null-handle' window (for MFC)

// Implementation

	// Generated message map functions
	//{{AFX_MSG(CGetTimeApp)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP();

  friend int _tmain(int argc, TCHAR* argv[], TCHAR* envp[]);
};

extern CGetTimeApp theApp;


// global function prototypes

VOID CmdInstallService(BOOL bStartFlag);
VOID CmdRemoveService(BOOL bUninstall);
VOID CmdDebugService(int argc, char **argv);
BOOL WINAPI ControlHandler ( DWORD dwCtrlType );
CString GetLastErrorText(void);

// service-oriented functions

VOID WINAPI service_ctrl(DWORD dwCtrlCode);
VOID WINAPI service_main(DWORD dwArgc, LPTSTR *lpszArgv);
BOOL ReportStatusToSCMgr(DWORD dwCurrentState,
                         DWORD dwWin32ExitCode,
                         DWORD dwWaitHint);
VOID AddToMessageLog(LPCTSTR lpszMsg, WORD wType = EVENTLOG_ERROR_TYPE);  // also works with debug mode

// service implementation

VOID ServiceStart(DWORD dwArgc, LPTSTR *lpszArgv);
VOID ServiceStop();




#endif // !defined(AFX_GETTIME_H__E9DDA65C_C10C_11D2_A41D_004033901FF3__INCLUDED_)
